# -*- coding: utf-8 -*-

"""
    Montreal Greek TV Add-on
    Author: Twilight0

        This program is free software: you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation, either version 3 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

import xbmcgui, xbmcplugin
from base64 import b64decode
from resources.lib import control, youtube, cache, directory, syshandle, sysaddon, action, url


# Misc variables:
addonicon = control.addonInfo('icon')
addonart = control.join(control.addonPath, 'resources/media')
livetv_img = control.join(addonart, 'livetv.png')
radio_img = control.join(addonart, 'radio.png')
youtube_img = control.join(addonart, 'youtube.png')
settings_img = control.join(addonart, 'settings.png')

# Links:
livetv_url = 'http://138.197.136.102:8081/live/greektv/playlist.m3u8'
radio_url = 'http://209.95.50.189:8049/stream'

# Handlers:


key = b64decode('QUl6YVN5QThrMU95TEdmMDNIQk5sMGJ5RDUxMWpyOWNGV28yR1I0')
ytid = 'UCFr8nqHDhA_fLQq2lEK3Mlw'


def yt():
    return youtube.youtube(key=key).videos(ytid)


def vod():

    video_list = cache.get(yt, 12)

    for v in video_list:
        v.update({'action': 'play', 'isFolder': 'False'})

    for item in video_list:
        refresh = {'title': 'Refresh', 'query': {'action': 'refresh'}}
        cache_clear = {'title': 'Cache Clear', 'query': {'action': 'cache_clear'}}
        item.update({'cm': [refresh, cache_clear]})

    directory.add(video_list)


def main_menu():

    # Live TV
    url1 = '{0}?action=play&url={1}'.format(sysaddon, livetv_url)
    li = xbmcgui.ListItem(label='Montreal Greek TV - Live', iconImage=livetv_img)
    li.setArt({'thumb': livetv_img, 'fanart': control.addonInfo('fanart')})
    li.setInfo('video', {'title': 'Montreal Greek TV - Live'})
    li.setProperty('IsPlayable', 'true')
    control.addItem(handle=syshandle, url=url1, listitem=li, isFolder=False)

    # Radio
    url2 = '{0}?action=play&url={1}'.format(sysaddon, radio_url)
    li = xbmcgui.ListItem(label='Montreal Greek Radio - Live', iconImage=radio_img)
    li.setArt({'thumb': radio_img, 'fanart': control.addonInfo('fanart')})
    li.setInfo('audio', {'title': 'Montreal Greek Radio - Live'})
    li.setProperty('IsPlayable', 'true')
    control.addItem(handle=syshandle, url=url2, listitem=li, isFolder=False)

    # Youtube
    url3 = '{0}?action=youtube'.format(sysaddon)
    li = xbmcgui.ListItem(label='Montreal Greek TV - Youtube Channel', iconImage=youtube_img)
    li.setArt({'thumb': youtube_img, 'fanart': control.addonInfo('fanart')})
    li.setInfo('video', {'title': 'Montreal Greek TV - Youtube Channel'})
    control.addItem(handle=syshandle, url=url3, listitem=li, isFolder=True)

    control.directory(syshandle)


def play_item(path):

    li = xbmcgui.ListItem(path=path)
    xbmcplugin.setResolvedUrl(syshandle, True, listitem=li)


if action is None:

    main_menu()

elif action == 'play':

    play_item(url)

elif action == 'youtube':

    vod()

elif action == 'settings':

    control.openSettings()
